#!/bin/env perl

use strict;
use File::Basename qw ( dirname );
use feature qw(say);

use DE_EPAGES::Core::API::Script                        qw( RunScript );
use DE_EPAGES::Core::API::File                          qw( GetFileContent );
use DE_EPAGES::Database::API::Config                    qw( BusinessUnits );
use DE_EPAGES::Database::API::Connection                qw( RunOnStore );

RunScript(
    'Sub' => \&Main
);

sub Main {
    local $| = 1;

    chdir dirname $0;

    my ($Stores) = _GetStores();

	    foreach my $Store (@$Stores) {
		say qq ("storelist: $Store");
		}
    foreach my $Store (@$Stores) {
        RunOnStore(
            Store => $Store,
            Sub => sub  {
				# say qq ("exec for store $Store");
				if ($Store ne "Site") {
					my $execPerl = "$ENV{PERL} $ENV{EPAGES_CARTRIDGES}/DE_EPAGES/PaymentTypes/Scripts/decryptDoubleEncryptedDebitBankAccountData.pl -storename $Store";
					say qq ("exec $execPerl");
					system($execPerl);
					$execPerl = "$ENV{PERL} $ENV{EPAGES_CARTRIDGES}/DE_EPAGES/Address/Scripts/decryptDoubleEncryptedBankAccountData.pl -storename $Store";
					say qq ("exec $execPerl");
					system($execPerl);
				}
            },
        );
    }
}

sub _GetStores {
    my ($Stores) = ([], {});

    foreach my $Store (@{_GetBusinessUnits()}) {
        push @$Stores, $Store unless $Store ~~ @$Stores;
    }
    return ($Stores);
}

sub _GetBusinessUnits {
    return [ sort split /\s+/, $ENV{EPAGES_BUSINESS_UNITS} ]
        if $ENV{EPAGES_BUSINESS_UNITS} =~ /\S/;
    return [ sort keys %{BusinessUnits()} ];
}